
// Copyright (C) 2002-2011 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __I_SOFTWARE_CONTEXT_H_INCLUDED__
#define __I_SOFTWARE_CONTEXT_H_INCLUDED__


#include "IrrCompileConfig.h"



#ifdef _IRR_COMPILE_WITH_SOFTWARE_

#include "IVideoContext.h"
#include "CImage.h"
#include "IZBuffer.h"
//#include "IImage.h"

namespace irr
{
namespace video
{

class IRenderWindow;
class CImage;
class IZBuffer;
class IStencilBuffer ;

// beginScene( void*)
// beginScene( IRenderWindow*)


class ISoftwareContext : public IVideoContext
{
public:
//IStencilBuffer* stencilBuffer,
    ISoftwareContext( IZBuffer* zBuffer, CImage* backBuffer,  const SVideoContextConfig& config) :
        IVideoContext(config,false)
        , ZBuffer(zBuffer)
        , BackBuffer(backBuffer)
        {
            _IRR_DEBUG_BREAK_IF( zBuffer == 0);
            _IRR_DEBUG_BREAK_IF( backBuffer == 0);
        };

    virtual ~ISoftwareContext()
    {

    }

    virtual bool swapBuffers(core::rect<s32>* src) = 0;

    /**
    Wait for an HDC on windows

    **/
    virtual bool setTarget(void* ) = 0;
//    getVideoDriver()


    virtual core::dimension2du getSize() const
    {
        return getConfig().ContextSize;
    };

    virtual bool setSize( const core::dimension2du& dims )
    {
        return false;
    }





//    IStencilBuffer* StencilBuffer;

    virtual void releaseContext()
    {


        if (BackBuffer)
            BackBuffer->drop();

        // delete zbuffer
        if (ZBuffer)
            ZBuffer->drop();

    }

// TODO makeprivate ? and create accessors ?
    CImage* BackBuffer;
    IZBuffer* ZBuffer;

};

}   // video
}   // irr

#endif // _IRR_COMPILE_WITH_SOFTWARE_

#endif
